<?php

namespace App\Modules\Utilitarios\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use App\Http\Controllers\Controller;
use App\Modules\Utilitarios\Models\Forpag;
use Yajra\Datatables\Datatables;
class ForpagController  extends Controller
{
    protected $table;
    function __construct(){
        $this->middleware('auth');
        $this->table = new Forpag();
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {   
        $data = $this->table::all();
        return view('Utilitarios.views.forpag')->with('forpag',$data);
    }
    /**
     * Display a listing of the datatables list.
     *
     */
    public function getTable()
    {   
        $table = Datatables::of($this->table::all());
        $table->addColumn('action', function($row){
            $url = url()->current().'/'.$row['id'];
            return view('layouts.buttons.buttons-dinamyc',['buttons'=> array(
                array('tipe'=>'edit',
                      'id_row'=>$row['id'],
                      'modal'=>'si',
                      'url'=>$url,
                      'class'=>" btn btn-sm  fn_edit btn-primary",
                      'icon'=>"icon-compose"
                ),
                array('tipe'=>'delete',
                      'id_row'=>$row['id'],
                      'modal'=>'no',
                      'url'=>$url,
                      'class'=>"btn btn-sm btn-danger fn_delete",
                      'icon'=>"icon-trash"
                )
            )]); 
        })->rawColumns(['action']);
        return $table->make(true);
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
       if ($request->has('action')) {
            switch ($request->input("action")) {
                case 'showtable':
                    return $this->getTable();    
                break;
                case 'add':
                    $validator = Validator::make($request->all(),[
                        'codigo' => 'required',
                        'descripcion' => 'required',
                    ]);
                     if ($validator->fails()) {
                       return response()->json(['error'=>$validator->errors()->all()]);
                    }else{
                        $this->table->fill($request->except(['action']))->save();
                        return response()->json(['success'=>'Registro agregado con exito','tablereload'=>'reload']);
                    }
                break;
                default:

                break;
            }
        }else{
             return response()->json(['error'=>'No existe ningun token por favor no borre nuesto codigo html']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $data =  $this->table::find($id);
        return view('Utilitarios.views.edit.forpag')->with('data',['pag'=>$data]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $this->table::find($id);
        if (!empty($data)) {
            $data->fill($request->all())->save();
            return response()->json(['success'=>'Registro actualizado con exito','tablereload'=>'reload']);
        }else{
            return response()->json(['error'=>'El registro no existe']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {   
        $destroy = $this->table::find($id);
        if (!empty($destroy)) {
            $destroy->delete();
            return response()->json(['success'=>'Registro eliminado con exito']);
        }
    }
}
